Bug 1260250 - Review Request: jxrlib - Open source implementation of jpegxr
Summary: Review Request: jxrlib - Open source implementation of jpegxr
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Nobody's working on this, feel free to take it
QA Contact: Jonathan Underwood
URL:
Whiteboard:
Depends On:
Blocks: 501993
TreeView+ depends on / blocked
 
Reported: 2015-09-05 00:50 UTC by Sandro Mani
Modified: 2015-09-24 14:19 UTC (History)
4 users (show)

Fixed In Version: 1.1-4.fc21
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-09-24 05:13:25 UTC
jonathan.underwood: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Sandro Mani 2015-09-05 00:50:57 UTC
Spec URL: https://smani.fedorapeople.org/review/jxrlib.spec
SRPM URL: https://smani.fedorapeople.org/review/jxrlib-1.1-1.fc24.src.rpm
Description: Open source implementation of jpegxr
Fedora Account System Username: smani

Comment 1 Christopher Meng 2015-09-05 01:00:15 UTC
Codeplex...

A better solution:

Source0: http://jxrlib.codeplex.com/downloads/get/685249#/jxrlib_%(echo %{version} | tr . _).tar.gz

Or sed hack whatever ;)

Comment 2 Sandro Mani 2015-09-05 10:21:37 UTC
Indeed, thanks! (Spec and SRPM refreshed)

Btw, this package is actually to allow the freeimage upgrade to 3.17.0. I see that you are also committer to the package - I wrote to Bruno Wolf III that I have worked on the upgrade, to also resolve the recently filed security vulnerability [1], with the result here [2].

[1] https://bugzilla.redhat.com/show_bug.cgi?id=1257859
[2] https://smani.fedorapeople.org/review/freeimage-3.17.0-1.fc24.src.rpm

Comment 3 Christopher Meng 2015-09-05 10:26:46 UTC
Of course I know this ;) I requested ACL from Bruno 2 years ago, trying to update it, but stopped due to personal reason.

I'm happy to review it but not now, still busy ;)

BTW I'd like to enhance source URL guideline for codeplex, I will submit it soon.

Comment 4 Jonathan Underwood 2015-09-08 09:49:01 UTC
Each time you update the package you need to bump the release number and repost the SPEC and SRPM URLs in the format you used in your initial submission comment- this allows tools such as the fedora review script to function.

At the moment you have a patch, and a CMakeLists.txt file as an extra source. You need to add a comment saying if these have been submitted upstream 9with a ticket or bug url if possible), or if not why not.

If you get these things fixed up, I'll do a review.

Comment 5 Sandro Mani 2015-09-08 11:20:30 UTC
Yeah, that's just me being lazy (since nobody actually started the review, I figured a simple re-upload wouldn't do any harm). But clearly during review I always do a release bump.

I've added some comments in the spec. Not particularly motivated to create Codeplex account just to post the patches and see them rot away - looking at other tickets filed there... My priority was to get things building to allow the freeimage upgrade.

SPEC URL: https://smani.fedorapeople.org/review/jxrlib.spec
SRPM URL: https://smani.fedorapeople.org/review/jxrlib-1.1-2.fc24.src.rpm

%changelog
* Tue Sep 08 2015 Sandro Mani <manisandro@gmail.com> - 1.1-2
- Comments for Patch0 and Source1

Comment 6 Jonathan Underwood 2015-09-08 13:16:03 UTC
(In reply to Sandro Mani from comment #5)
> I've added some comments in the spec. Not particularly motivated to create
> Codeplex account just to post the patches and see them rot away - looking at
> other tickets filed there... My priority was to get things building to allow
> the freeimage upgrade.
> 

Pushing patches upstream is one of the core responsibilities of a Fedora package maintainer. 

https://fedoraproject.org/wiki/Packaging:Guidelines#All_patches_should_have_an_upstream_bug_link_or_comment

So, I realize it's a pain, but to pass package review I am afraid you do need to push the patch upstream.

> SPEC URL: https://smani.fedorapeople.org/review/jxrlib.spec
> SRPM URL: https://smani.fedorapeople.org/review/jxrlib-1.1-2.fc24.src.rpm
> 
> %changelog
> * Tue Sep 08 2015 Sandro Mani <manisandro@gmail.com> - 1.1-2
> - Comments for Patch0 and Source1

Comment 7 Sandro Mani 2015-09-08 13:29:05 UTC
Fair enough (hurray trying to avoid giving my phone number to microsoft for "account verification purposes")

https://jxrlib.codeplex.com/workitem/13

Will add the link to the spec next refresh, or before import.

Comment 8 Jonathan Underwood 2015-09-08 13:33:22 UTC
(In reply to Sandro Mani from comment #7)
> Fair enough (hurray trying to avoid giving my phone number to microsoft for
> "account verification purposes")
> 
> https://jxrlib.codeplex.com/workitem/13
> 
> Will add the link to the spec next refresh, or before import.

Ugh. You have my sympathies.

Running a review now.

Comment 9 Jonathan Underwood 2015-09-08 13:51:48 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

Issues
- It would be nice to do a rm -rf bin in %prep to remove the bundled
  binaries, just for sanity. 

- In the doc directory there is a word document describing the file
  format etc. It would be possible to make a PDF of this using
  libreoffice with

  libreoffice --headless --convert-to pdf JPEGXR_DPK_Spec_1.0.doc

  I would normally say this is optional, but actually, this doc
  contains the license for the software, so is the closest thing to a
  LICENSE file. So, although it adds buildtime bloat installing
  libreoffice, I'd encourage you to build the pdf and ship it as a
  %doc. But it's not mandatory.

- See various things below.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.

The license is included in the doc file mentioned above, which is not
technically "in its own file".

[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (2 clause)". Detailed output of licensecheck in
     /home/jgu/Fedora/1260250-jxrlib/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[!]: Package complies to the Packaging Guidelines

Patches need a comment with a link to upstream ticket (I know you're
taking care of that as I type this).

[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Sources can be downloaded from URI in Source: tag
     Note: Could not download Source0:
     http://jxrlib.codeplex.com/downloads/get/685249#/jxrlib_1_1.tar.gz
     See: http://fedoraproject.org/wiki/Packaging:Guidelines#Tags

OK, the current Source0 url doesn't work. I say coedplex is a bit of a
nightmare in this regard. Can you come up with something that works?

[!]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.

The absence of a LICENSE or COPYING file should be raised upstream.

[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.

See above.

[x]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: jxrlib-1.1-2.fc24.x86_64.rpm
          jxrlib-devel-1.1-2.fc24.x86_64.rpm
          jxrlib-1.1-2.fc24.src.rpm
jxrlib.x86_64: W: spelling-error Summary(en_US) jpegxr -> JPEG
jxrlib.x86_64: W: spelling-error %description -l en_US jpegxr -> JPEG
jxrlib.x86_64: W: no-manual-page-for-binary JxrDecApp
jxrlib.x86_64: W: no-manual-page-for-binary JxrEncApp
jxrlib-devel.x86_64: W: only-non-binary-in-usr-lib
jxrlib-devel.x86_64: W: no-documentation
jxrlib.src: W: spelling-error Summary(en_US) jpegxr -> JPEG
jxrlib.src: W: spelling-error %description -l en_US jpegxr -> JPEG
jxrlib.src: W: invalid-url Source0: http://jxrlib.codeplex.com/downloads/get/685249#/jxrlib_1_1.tar.gz HTTP Error 404: Not Found
3 packages and 0 specfiles checked; 0 errors, 9 warnings.




Rpmlint (debuginfo)
-------------------
Checking: jxrlib-debuginfo-1.1-2.fc24.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
jxrlib-devel.x86_64: W: only-non-binary-in-usr-lib
jxrlib-devel.x86_64: W: no-documentation
jxrlib.x86_64: W: private-shared-object-provides /usr/lib64/libjxrglue.so.0.0.0 libjxrglue.so.0()(64bit)
jxrlib.x86_64: W: private-shared-object-provides /usr/lib64/libjpegxr.so.0.0.0 libjpegxr.so.0()(64bit)
jxrlib.x86_64: W: no-manual-page-for-binary JxrEncApp
jxrlib.x86_64: W: no-manual-page-for-binary JxrDecApp
3 packages and 0 specfiles checked; 0 errors, 6 warnings.



Requires
--------
jxrlib-devel (rpmlib, GLIBC filtered):
    jxrlib(x86-64)
    libjpegxr.so.0()(64bit)
    libjxrglue.so.0()(64bit)

jxrlib (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libjpegxr.so.0()(64bit)
    libjxrglue.so.0()(64bit)
    libm.so.6()(64bit)
    rtld(GNU_HASH)



Provides
--------
jxrlib-devel:
    jxrlib-devel
    jxrlib-devel(x86-64)

jxrlib:
    jxrlib
    jxrlib(x86-64)
    libjpegxr.so.0()(64bit)
    libjxrglue.so.0()(64bit)



Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1260250
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 10 Sandro Mani 2015-09-08 14:13:36 UTC
- Shipped PDF variant of JPEGXR_DPK_Spec_1.0.doc as separate source (mainly because libreoffice has broken dependencies in rawhide right now, but it also reduces overhead)
- Hard to find a better download URL. The direct URL is

http://download-codeplex.sec.s-msft.com/Download/Release?ProjectName=jxrlib&DownloadId=685249&FileTime=130142428055530000&Build=21031

but I have no idea how stable that url is.


SPEC URL: https://smani.fedorapeople.org/review/jxrlib.spec
SRPM URL: https://smani.fedorapeople.org/review/jxrlib-1.1-3.fc24.src.rpm

%changelog
* Tue Sep 08 2015 Sandro Mani <manisandro@gmail.com> - 1.1-3
- Add Patch0 and Source1 upstream links
- Ship pdf variant of JPEGXR_DPK_Spec_1.0.doc in %%doc
- Remove bin folder

Comment 11 Jonathan Underwood 2015-09-08 14:17:07 UTC
OK, APPROVED. 

a) Please do continue to investigate whether you can work out a recipe for a sensible source URL - perhaps cicku (Christopher Meng) has some thoughts on this.

b) Please do file a ticket with upstream asking them to include a copy of the BSD license file with their sources too.

Comment 12 Sandro Mani 2015-09-08 14:23:46 UTC
b) Added to the previous ticket https://jxrlib.codeplex.com/workitem/13

Thanks for the quick review!


New Package SCM Request
=======================
Package Name: jxrlib
Short Description: Open source implementation of jpegxr
Owners: smani
Branches: f23 f22 f21
InitialCC:

Comment 13 Gwyn Ciesla 2015-09-09 12:50:26 UTC
Git done (by process-git-requests).

Comment 14 Fedora Update System 2015-09-09 13:24:45 UTC
jxrlib-1.1-3.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2015-15447

Comment 15 Fedora Update System 2015-09-09 13:24:45 UTC
jxrlib-1.1-3.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-15446

Comment 16 Fedora Update System 2015-09-09 13:24:50 UTC
jxrlib-1.1-3.fc21 has been submitted as an update to Fedora 21. https://bodhi.fedoraproject.org/updates/FEDORA-2015-15448

Comment 17 Fedora Update System 2015-09-10 01:02:59 UTC
jxrlib-1.1-3.fc21 has been pushed to the Fedora 21 testing repository. If problems still persist, please make note of it in this bug report.\nIf you want to test the update, you can install it with \n su -c 'yum --enablerepo=updates-testing update jxrlib'. You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-15448

Comment 18 Fedora Update System 2015-09-10 02:07:30 UTC
jxrlib-1.1-3.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.\nIf you want to test the update, you can install it with \n su -c 'yum --enablerepo=updates-testing update jxrlib'. You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-15447

Comment 19 Fedora Update System 2015-09-10 05:51:33 UTC
jxrlib-1.1-3.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.\nIf you want to test the update, you can install it with \n su -c 'yum --enablerepo=updates-testing update jxrlib'. You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-15446

Comment 20 Fedora Update System 2015-09-11 16:34:50 UTC
jxrlib-1.1-4.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-15625

Comment 21 Fedora Update System 2015-09-11 16:34:50 UTC
jxrlib-1.1-4.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2015-15624

Comment 22 Fedora Update System 2015-09-11 16:34:58 UTC
jxrlib-1.1-4.fc21 has been submitted as an update to Fedora 21. https://bodhi.fedoraproject.org/updates/FEDORA-2015-15626

Comment 23 Fedora Update System 2015-09-12 21:25:25 UTC
jxrlib-1.1-4.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.\nIf you want to test the update, you can install it with \n su -c 'yum --enablerepo=updates-testing update jxrlib'. You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-15625

Comment 24 Fedora Update System 2015-09-13 03:49:15 UTC
jxrlib-1.1-4.fc21 has been pushed to the Fedora 21 testing repository. If problems still persist, please make note of it in this bug report.\nIf you want to test the update, you can install it with \n su -c 'yum --enablerepo=updates-testing update jxrlib'. You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-15626

Comment 25 Fedora Update System 2015-09-13 04:20:28 UTC
jxrlib-1.1-4.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.\nIf you want to test the update, you can install it with \n su -c 'yum --enablerepo=updates-testing update jxrlib'. You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-15624

Comment 26 Fedora Update System 2015-09-24 05:13:15 UTC
jxrlib-1.1-4.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Comment 27 Fedora Update System 2015-09-24 08:25:16 UTC
jxrlib-1.1-4.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.

Comment 28 Fedora Update System 2015-09-24 14:19:02 UTC
jxrlib-1.1-4.fc21 has been pushed to the Fedora 21 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.